Download it now!
Bug 98333 - Bringing uniformity to styles shortcuts
Summary: Bringing uniformity to styles shortcuts
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
5.2.0.0.alpha0+
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsUXEval
Depends on:
Blocks: Shortcuts-Accelerators
  Show dependency treegraph
 
Reported: 2016-03-02 06:45 UTC by Yousuf Philips (jay) (retired)
Modified: 2016-09-19 18:01 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) (retired) 2016-03-02 06:45:33 UTC
Presently the styles shortcuts used in Libreoffice arent uniform across the apps and the F11 shortcut used for Styles and Formatting isnt a suitable shortcut according to norms on Windows, as well as Gnome and KDE HIGs.

Current Behaviour:
F11 - Styles & Formatting
Shift + F11 - New Style (Writer)
Ctrl + Shift + F11 - Update Style (Writer)
Ctrl + F11 - .uno:StyleCatalog (Calc, Impress)

New Behaviour:
Ctrl + Shift + F11 - Styles & Formatting (using the same Ctrl + Shift combination now found with Data Sources and Navigator)
Ctrl + F11 - New Style
Ctrl + Alt + F11 - Update Style
Ctrl + Alt + Shift + F11 - .uno:StyleCatalog
---
F11 - Changed to fullscreen (default on Windows, Gnome and KDE)
Shift + F11 - Reserved as need by Calc for insert sheet
Alt + F11 - Reserved for opening LO Basic Editor
Comment 1 Cor Nouws 2016-03-02 09:41:29 UTC
Additional info: in Writer Ctrl+F11 has the much appreciated function of putting the focus in list "Apply style"
Comment 2 Cor Nouws 2016-03-02 09:43:03 UTC
Note: issues about F11/full screen always have been resolved to WontFix. So will be an interesting discussion.
Comment 3 Yousuf Philips (jay) (retired) 2016-03-02 12:54:34 UTC
(In reply to Cor Nouws from comment #1)
> Additional info: in Writer Ctrl+F11 has the much appreciated function of
> putting the focus in list "Apply style"

The keyboard shortcut entry had it as 'Set focus to combobox' and i was puzzled by it. Thanks for that. Any ideas what Ctrl+F11 in Calc and Impress does?

(In reply to Cor Nouws from comment #2)
> Note: issues about F11/full screen always have been resolved to WontFix. So
> will be an interesting discussion.

Yep i had one of those wontfix discussions in bug 83467 (you were in that discussion :D), but more reasons to do so have showed up.

1) Other single key function keys (Data Sources, Navigator) are being moved to having Ctrl + Shift to unify their functionality.

2) F11 isnt default on Mac as its a reserved key on the Mac OS and its HIG has stated a suitable shortcut for this function.

3) Styles & Formatting is always visible and easily accessible in sidebar.

Respecting the norms of a platform, which are defined in their HIG, make it easier for users to adopt and feels it feel more like a native application. I'm doing the same thing for mac shortcuts (bug 98290).
Comment 4 V Stuart Foote 2016-03-02 14:34:00 UTC
This shuffle of the Style related F11 key combos makes sense as proposed. Including then assigning F11 for fullscreen toggle. 

Would that be as an alternate to or simply replacing current <ctrl><shift>+J view toggle?

Any case folks will need a road map of changes, please keep up with those in the Help/Wiki and guides.
Comment 5 Yousuf Philips (jay) (retired) 2016-03-02 15:44:59 UTC
(In reply to V Stuart Foote from comment #4)
> Would that be as an alternate to or simply replacing current <ctrl><shift>+J
> view toggle?

Would replace it as heiko stated its not good to waste a second shortcut ("And I wouldn't waste two shortcuts for one function." bug 97906 Comment 31)

> Any case folks will need a road map of changes, please keep up with those in
> the Help/Wiki and guides.

Yes all changes are being tracked in google docs and whenever anything is committed, it will be added to the release notes.
Comment 6 Cor Nouws 2016-03-02 19:32:06 UTC
(In reply to Yousuf (Jay) Philips from comment #3)
> (In reply to Cor Nouws from comment #1)
> > Additional info: in Writer Ctrl+F11 has the much appreciated function of
> > putting the focus in list "Apply style"
> 
> The keyboard shortcut entry had it as 'Set focus to combobox' and i was
> puzzled by it. Thanks for that. 

You're welcome and I'm giving thanks in advance for a nice solution here.. such as:

Ctrl + Alt + F11 - Select combobox Apply Style
Ctrl + Alt + Shift + F11 - Update Style
(Combobox is used more ofthen then the Update style function.)


>  Any ideas what Ctrl+F11 in Calc and Impress does?

In older times, there was a separate style handling window, with more buttons for apply, update. Really cool basically, but forgotten and such. That must have been uno:StyleCatalog.
See this 
 https://cgit.freedesktop.org/libreoffice/core/commit/?id=a5e835dafd73d9d5bd499846a4bba5b58dafbca0

> (In reply to Cor Nouws from comment #2)

> Yep i had one of those wontfix discussions in bug 83467 (you were in that
> discussion :D), but more reasons to do so have showed up.
> 
> 1) Other single key function keys (Data Sources, Navigator) are being moved
> to having Ctrl + Shift to unify their functionality.

Fine.
(Lets switch Insert Comment to Ctrl+Shift+C too then, and not ALt+Shft+C)

> 2) F11 isnt default on Mac as its a reserved key on the Mac OS and its HIG
> has stated a suitable shortcut for this function.

OK.

> 3) Styles & Formatting is always visible and easily accessible in sidebar.

Not for people opening it when needed.

But no huge concerns on my side.
Comment 7 Yousuf Philips (jay) (retired) 2016-03-03 02:41:01 UTC
(In reply to Cor Nouws from comment #6)
> You're welcome and I'm giving thanks in advance for a nice solution here..
> such as:
> 
> Ctrl + Alt + F11 - Select combobox Apply Style
> Ctrl + Alt + Shift + F11 - Update Style
> (Combobox is used more ofthen then the Update style function.)

If the combobox is that important then we should leave it with Ctrl + F11 and remove the incorrectly assigned .uno:StyleCatalog from Calc and Impress. So the revised new behaviour would be

Ctrl + Shift + F11 - Styles & Formatting
Ctrl + F11 - Set focus to combobox (.uno:ActivateStyleApply)
Ctrl + Alt + F11 - New Style
Ctrl + Alt + Shift + F11 - Update Style

Or do you think New Style and Update Style be swapped?

> > Yep i had one of those wontfix discussions in bug 83467 (you were in that
> > discussion :D), but more reasons to do so have showed up.
> > 
> > 1) Other single key function keys (Data Sources, Navigator) are being moved
> > to having Ctrl + Shift to unify their functionality.
> 
> Fine.
> (Lets switch Insert Comment to Ctrl+Shift+C too then, and not ALt+Shft+C)

C isnt an single key function key, so why the suggestion? Also Ctrl+Shift+C wont work on Mac, as it is reserved as a different kind of Copy shortcut.
Comment 8 Niklas Johansson 2016-03-04 08:33:19 UTC
If LibreOffice isn't going to keep the F11 shortcut for the Styles and Formatting dialog why not move towards the mac shortcut Command+T (Ctrl+T on Windows/Linux) which is already used in the mac version. And as far as I can see isn't used by any LibreOffice application?
That way we also get consistency between operating systems.

Ctrl+Shift+T seems to be used by Calc and Writer but otherwise I didn't see any uses of the variants of <modifier keys>+T. 

And just for reference the normal keyboard shortcut for full screen on mac seems to be Command+Control+F, and F11 shows the desktop.
Comment 9 Yousuf Philips (jay) (retired) 2016-03-05 01:10:26 UTC
(In reply to Niklas Johansson from comment #8)
> If LibreOffice isn't going to keep the F11 shortcut for the Styles and
> Formatting dialog why not move towards the mac shortcut Command+T (Ctrl+T on
> Windows/Linux) which is already used in the mac version.

Apple's HIG has Cmd+T mapped to "Display the Fonts window (equivalent to Format > Font > Show Fonts)" which is equivalent to our Format > Character and was wrongly assigned to Styles & Formatting, as clearly can be seen in the below window.

https://www.youtube.com/watch?v=_oartY48Q_g

> And as far as I can see isn't used by any LibreOffice application?
> That way we also get consistency between operating systems.

That is presently true, but with the future switch of Cmd+T off of Styles & Formatting on Mac, we have lost consistency again.

> Ctrl+Shift+T seems to be used by Calc and Writer but otherwise I didn't see
> any uses of the variants of <modifier keys>+T. 

Ctrl+Alt+T is reserved on Linux.

> And just for reference the normal keyboard shortcut for full screen on mac
> seems to be Command+Control+F, and F11 shows the desktop.

Yes it is mentioned in the HIG, that is why its in my first patch to fix mac shortcuts. Do you happen to be a mac user Niklas?
Comment 10 Niklas Johansson 2016-03-07 11:49:38 UTC
(In reply to Yousuf (Jay) Philips from comment #9)
...
> 
> Apple's HIG has Cmd+T mapped to "Display the Fonts window ...

Sorry, I should have double checked before commenting.

...
> 
> Yes it is mentioned in the HIG, that is why its in my first patch to fix mac
> shortcuts. Do you happen to be a mac user Niklas?

Thanks, for working on this. I use mac from time to time, so just let me know if you want me to test something.
Comment 11 Eike Rathke 2016-03-15 20:09:19 UTC
I learned about this pending request while a disagreed with the change of F5 to Shift+Ctrl+F5 for the Navigator in https://gerrit.libreoffice.org/23201. I'll repeat my reasoning here.

Shift+Ctrl+Anything requires two hands to hit. Using that for something basic and outstanding as the Stylist or Navigator is an un-usability. Additionally, both features are something that other office suites don't offer and that help to organize the document and its formatting, users of some other suite don't even know styles or the possibilities the Navigator offers. Easy accessibility is a key to promote these further.
Comment 12 V Stuart Foote 2016-03-15 21:07:23 UTC
To UX-advise to resolve merit of doing this consolidation.

https://gerrit.libreoffice.org/#/c/23201/

Sorry Eike, understand the appeal of maintaining status quo, but the Short-cut consolidation really is long overdue.

F4 for Data Sources, F5 for Navigator, and F11 all as single key short-cuts assigned to launch Styles & Formatting dialogs predate implementation of GUI Sidebar offering single button widget activation. 

Shifting these shortcuts to be multi-key entry using assignments for KEY_MOD1, KEY_MOD2, SHIFT presents few true short-term hardships but has advantage of allowing us to reduce collisions with OS reserved keys or HIG recommendations.

We've already gutted most menu structure and accelerator assignments--IMHO this is just a continuation of the process.  Painful in the transitional phase, but freeing the UI implementation for a better and more consistent UX.

Key to getting the transition done and accepted by users is to make it consistent and to not drag it out over multiple releases. And to follow-up in documentation, both the built-in/online help and in Wiki topical pages.
Comment 13 Cor Nouws 2016-03-16 16:08:22 UTC
(In reply to Eike Rathke from comment #11)

> Shift+Ctrl+Anything requires two hands to hit. Using that for something
> basic and outstanding as the Stylist or Navigator is an un-usability.
> Additionally, both features are something that other office suites don't
> offer and that help to organize the document and its formatting, users of
> some other suite don't even know styles or the possibilities the Navigator
> offers. Easy accessibility is a key to promote these further.

To be honest: I fully agree.


(In reply to V Stuart Foote from comment #12)

> F4 for Data Sources, F5 for Navigator, and F11 all as single key short-cuts
> assigned to launch Styles & Formatting dialogs predate implementation of GUI
> Sidebar offering single button widget activation. 

Does it make sense to compare short cuts with using a mouse?

> Shifting these shortcuts to be multi-key entry using assignments for
> KEY_MOD1, KEY_MOD2, SHIFT presents few true short-term hardships but has
> advantage of allowing us to reduce collisions with OS reserved keys or HIG
> recommendations.

Reduce collision with OS reserved, makes sense. Recommendations should help, and if not, be ignored in specific cases.

> We've already gutted most menu structure and accelerator assignments--IMHO
> this is just a continuation of the process.  Painful in the transitional
> phase, but freeing the UI implementation for a better and more consistent UX.

Better in the sense that important features are hard to access..
I guess we have to think about an extension to make important functions easy accessible again. :\
Comment 14 Yousuf Philips (jay) (retired) 2016-03-17 09:10:48 UTC
(In reply to Eike Rathke from comment #11)
> Shift+Ctrl+Anything requires two hands to hit. Using that for something
> basic and outstanding as the Stylist or Navigator is an un-usability.

We have many common shortcut that require two hands to hit that are even more basic than stylist or navigator, e.g. Ctrl + P (Print), Ctrl + O (Open), Ctrl + N (New). On Mac, users have to use two hands to hit any of the Function keys, as they have to press the Fn key as well.

> Additionally, both features are something that other office suites don't
> offer and that help to organize the document and its formatting, 

MS Office has both a stylist (http://www.addbalance.com/usersguide/images/stylesFPane2010.gif) and navigator (http://www.dkszone.net/editing-in-ms-word-2010-simplified-with), though not as powerful/extensive as the one found in LO. Both of these tools are useful for those who utilize them.

> users of
> some other suite don't even know styles or the possibilities the Navigator
> offers. Easy accessibility is a key to promote these further.

Particular users of all office suites dont know/use styles and having a stylist in LO wont change that behaviour. There are users who use styles (normally more advanced users) and users who dont use styles (normally less advanced users) and that wont ever change unless direct formatting is completely eliminated. In the same way, we have users who may use the Navigator (advanced users) and users who likely wont (non-advanced users).

We should make the stylist and navigator available to those who use it, but we should avoid assigning them to shortcut keys that are an OS standard for something else in order to improve LO integrate with those OSes and reduce the learning curve for users. Imagine what users would say if we has assigned Ctrl + Z to anything else but undo.
Comment 15 Cor Nouws 2016-03-17 23:40:11 UTC
Hi Jay,

(In reply to Yousuf (Jay) Philips from comment #14)

> We have many common shortcut that require two hands to hit that are even
> more basic than stylist or navigator, e.g. Ctrl + P (Print), Ctrl + O
> (Open), Ctrl + N (New). On Mac, users have to use two hands to hit any of
> the Function keys, as they have to press the Fn key as well.

It might be because I use Ctrl+P and Ctr+O quite seldom, or because Ctrl+Shift asks for a little twist and/combined with the move from my right hand to the left side of the key board, that for me this has a different weight.

I can't imagine that it is because we get old and grumpy... isn't it, Eike ?

> > Additionally, both features are something that other office suites don't
> > offer and that help to organize the document and its formatting, 
> 
> MS Office has both a stylist
> (http://www.addbalance.com/usersguide/images/stylesFPane2010.gif) and
> navigator (http://www.dkszone.net/editing-in-ms-word-2010-simplified-with),

I never liked that styles window, but maybe it is better now. After all. MsOffice improves too, as they do with a simple version of the Navigator.

> though not as powerful/extensive as the one found in LO. Both of these tools
> are useful for those who utilize them.

Sure.

> Particular users of all office suites dont know/use styles and having a
> stylist in LO wont change that behaviour. There are users who use styles
> (normally more advanced users) and users who dont use styles (normally less
> advanced users) and that wont ever change unless direct formatting is
> completely eliminated. In the same way, we have users who may use the
> Navigator (advanced users) and users who likely wont (non-advanced users).
> 
> We should make the stylist and navigator available to those who use it, but
> we should avoid assigning them to shortcut keys that are an OS standard for
> something else in order to improve LO integrate with those OSes and reduce
> the learning curve for users. Imagine what users would say if we has
> assigned Ctrl + Z to anything else but undo.

Maybe indeed for new/basic users, good visibility in the Side bar is more important, yes.

Cheers - Cor
Comment 16 Heiko Tietze 2016-03-18 07:06:06 UTC
From the W7 HIG:
<cite>
* Use function keys for commands that have a small-scale effect, such as commands that apply to the selected object. For example, F2 renames the selected item.
* Use Ctrl key combinations for commands that have a large-scale effect, such as commands that apply to an entire document. For example, Ctrl+S saves the current document.
* Use Shift key combinations for commands that extend or complement the actions of the standard shortcut key. For example, the Alt+Tab shortcut key cycles through open primary windows, whereas Alt+Shift+Tab cycles in the reverse order. Similarly, F1 displays Help, whereas Shift+F1 display context-sensitive Help.
* Don’t use the following characters for shortcut keys: @ £ $ {} [] \ ~ | ^ ' < >. These characters require different key combinations across languages or are locale specific.
* Don’t use Ctrl+Alt combinations, because Windows interprets this combination in some language versions as an AltGR key, which generates alphanumeric characters.
</cite>

Not sure if we have to adopt this guideline.

Personally I'm always afraid of using ctrl/alt modifiers together with function keys because of switching to another terminal. And I can hardly imagine that any three-finger salute is really used in the wild. We should consider to drop those shortcuts - or reserve it for the least important functions. In other words the more important a function is or the more frequently it is being used the less modifiers it has to use.

Ctrl + F11 - Styles & Formatting (Changes to F11 make sense only when we also free the other single functions keys. So this would makes it necessary to use Ctrl+F5 for Navigator and Ctrl+F4 for Data Source.)
Ctrl + Shift + F11 - Set focus to combobox (.uno:ActivateStyleApply)

<strikeout>
Ctrl + Alt + F11 - New Style
Ctrl + Alt + Shift + F11 - Update Style
</strikeout>

To add another argument: We have Ctrl+1..9 to set some style directly, so why not use Ctrl+0 (or ^) instead of F11? I know it breaks all familiarization...

And last but not least about transition: We need a better customization regarding toolbar/sidebar setup anyway. We could (or rather should) add shortcuts. And since the idea is to have an option to switch between different layouts it could be possible to activate either the old LibO4 shortcut layout or anything else.
Comment 17 Yousuf Philips (jay) (retired) 2016-03-18 08:30:33 UTC
(In reply to Heiko Tietze from comment #16)
> * Don’t use the following characters for shortcut keys: @ £ $ {} [] \ ~ | ^
> ' < >. These characters require different key combinations across languages
> or are locale specific.

I guess this is where Mac differs from Windows, as its HIG utilizes { | } and iWork utilizes [ ] < > '.

> Ctrl + F11 - Styles & Formatting (Changes to F11 make sense only when we
> also free the other single functions keys. So this would makes it necessary
> to use Ctrl+F5 for Navigator and Ctrl+F4 for Data Source.)

Not possible to use Ctrl+F4 as that is a reserved shortcut to close the application.

> <strikeout>
> Ctrl + Alt + F11 - New Style

You are correct that this wouldnt work on Linux.

> Ctrl + Alt + Shift + F11 - Update Style
> </strikeout>

These two would likely need shortcuts not involving F11

> To add another argument: We have Ctrl+1..9 to set some style directly, so
> why not use Ctrl+0 (or ^) instead of F11? I know it breaks all
> familiarization...

Ctrl + 0 is taken by the 'Text body' paragraph style in Writer and Ctrl + Shift + 6 is taken in Calc for a number format.

> And last but not least about transition: We need a better customization
> regarding toolbar/sidebar setup anyway. We could (or rather should) add
> shortcuts.

Sidebar shortcuts discussion is here (bug 84502).

> And since the idea is to have an option to switch between
> different layouts it could be possible to activate either the old LibO4
> shortcut layout or anything else.

This has been implemented in Calc, but isnt available in other apps.
Comment 18 Robinson Tryon (qubit) 2016-08-25 05:49:38 UTC Comment hidden (obsolete)
Comment 19 Cor Nouws 2016-09-19 16:28:18 UTC
why Writer, Heiko?
see comment #0